##!/usr/bin/env perl
# shorturl application package
package ShortURL;
use MIME::Base64;
use Mojolicious::Lite;

my $config = plugin 'json_config';

sub get_url{
    my $self = shift;
    my ($short_url) = @_;

    app->log->debug("get_url: acces au fichier de stockage \'$config->{storage_file}\'");

    open(FILE, "$config->{storage_file}")
        or die "erreur d'acces a \'$config->{storage_file}\'\n$!";
    # lecture non bloquante
    flock(FILE, 4);
    while(<FILE>){
        if ($_ =~ /$short_url/){
            my @url_line = split(/\|/,$_);
            return decode_base64($url_line[1]);
        }
    }
    close(FILE);
    #url non trouvee, retourne -1
    return -1;
}

sub store_url{
    my $self = shift;
    my ($url_orig) = @_;
    chomp $url_orig;
    my $b64_url = encode_base64($url_orig, "");

    my $short_url = "!".sprintf("%x",time);

    app->log->debug("store_url: acces au fichier de stockage \'$config->{storage_file}\'");

    open(STORAGE, ">> $config->{storage_file}")
        or die "erreur d'acces a \'$config->{storage_file}\'\n$!";
    print STORAGE "$short_url|$b64_url\n";
    close STORAGE;

    return $short_url;
}

1;
